import evlasciencedatamodel as sc
import NGASUtil as ng
import persistmetadata as pm
import argparse
import glob
import os
import shutil
from pycapo import CapoConfig
from lxml import objectify as obj
import tarfile
from persistcaltables import persistcalibrations

# TODO incorporate this in as an option of archive.py ?
# Capofy the location of the temporary location for tar unpacking
# No manifest file?

def main():
    parser = argparse.ArgumentParser(description='Ingest Calibration Tables')
    parser.add_argument('-f', '--file', help='Calibration File')
    args = parser.parse_args()


    capoprofile = os.environ['CAPO_PROFILE']
    config = CapoConfig(profile=capoprofile)
    calibrationtablepath = config.getstring('archive-ingestion.CalibrationTablePath')

    if args.file is None:
        tarfiles = glob.glob(calibrationtablepath + '/*.tar')
    else:
        tarfiles = []
        tarfiles.append(os.path.join(calibrationtablepath, args.file))
    print('{} calibration file(s) to be archived'.format(len(tarfiles)))
    calcount = 0
    calibrationfiles = []
    for calfile in tarfiles:
        print('Tar file to be ingested: {}'.format(tarfile))
        calcount += 1
        calibrationfiles.append(calfile)

    ng.archivefiles(calibrationfiles)
    print('Total of {} calibrations(s) ingested'.format(calcount))
    persistcalibrations(calibrationfiles)


if __name__ == '__main__':
    # Do the argparse thing
    main()
